using System;
using System.Text;
using System.Collections;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using Microsoft.Win32;
using System.IO;

namespace OlSenderNameModificationExample
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("75DE751B-3BD0-45C6-8B65-0676214D14BA"), ProgId("OlSenderNameModificationExample.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
        }

        private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.ItemSend += new AddinExpress.MSO.ADXOlItemSend_EventHandler(this.adxOutlookEvents_ItemSend);
            // 
            // AddinModule
            // 
            this.AddinName = "OlSenderNameModificationExample";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private class MAPI
        {
            public const uint PR_TRANSPORT_MESSAGE_HEADERS = 0x7D001E;
            public const uint PR_BODY = 0x1000001E;
            public const uint PR_BODY_HTML = 0x1013001E;
            public const uint PR_HTML = 0x10130102;

            public const uint PT_STRING8 = 30;
            public const uint PR_SENDER_ADDRTYPE = (PT_STRING8 | (0x0C1E << 16));
            public const uint PR_SENDER_EMAIL_ADDRESS = (PT_STRING8 | (0x0C1F << 16));
            public const uint PR_SENDER_NAME = (PT_STRING8 | (0x0C1A << 16));

            public const uint PR_NEWMESSAGE_SENDER_EMAIL_ADDRESS = unchecked((uint)(PT_STRING8 | (0x8033 << 16)));


            public struct SPropValue
            {
                public uint ulPropTag;
                public uint dwAlignPad;
                public long Value;
            }

            [DllImport("MAPI32.DLL", CharSet = CharSet.Ansi, EntryPoint = "HrGetOneProp@12")]
            public static extern void HrGetOneProp(IntPtr pmp, uint ulPropTag, out IntPtr ppProp);

            [DllImport("MAPI32.DLL", CharSet = CharSet.Ansi, EntryPoint = "MAPIFreeBuffer@4")]
            public static extern void MAPIFreeBuffer(IntPtr lpBuffer);
        }

        private class Accounts
        {
            private string defaultAccount = String.Empty;
            private string defaultEmail = String.Empty;
            private const string PathXP = "9375CFF0413111d3B88A00104B2A6676";
            private const string RegXP = "{ED475418-B0D6-11D2-8C3B-00104B2A6676}";
            private SortedList accounts;
            private SortedList emails;
            private string registryPath;

            public Accounts()
            {
                defaultAccount = String.Empty;
                this.accounts = new SortedList();
                this.emails = new SortedList();
            }

            public string DefaultAccount
            {
                get
                {
                    return defaultAccount;
                }
            }

            public string DefaultEmail
            {
                get
                {
                    return defaultEmail;
                }
            }

            public void Load(string hostVersion)
            {
                int version = 0;

                accounts.Clear(); emails.Clear();

                int index = hostVersion.IndexOf('.');
                if (index > 0)
                    version = Convert.ToInt32(hostVersion.Substring(0, index));

                if (version >= 10)
                {
                    if (Environment.OSVersion.Platform == PlatformID.Win32NT)
                        registryPath = "Software\\Microsoft\\Windows NT\\CurrentVersion\\Windows Messaging Subsystem\\Profiles";
                    else
                        registryPath = "Software\\Microsoft\\Windows Messaging Subsystem\\Profiles";

                    using (RegistryKey key = Registry.CurrentUser.OpenSubKey(registryPath, false))
                    {
                        if (key != null)
                        {
                            string defaultProfile = (string)key.GetValue("DefaultProfile", String.Empty);
                            if (defaultProfile != String.Empty)
                            {
                                using (RegistryKey subKey = key.OpenSubKey(defaultProfile, false))
                                {
                                    if (subKey != null)
                                    {
                                        if (subKey.SubKeyCount > 0)
                                        {
                                            using (RegistryKey subKey2 = subKey.OpenSubKey(PathXP, false))
                                            {
                                                if (subKey2 != null)
                                                {
                                                    if (subKey2.SubKeyCount > 0)
                                                    {
                                                        byte[] bytes = (byte[])subKey2.GetValue(RegXP, null);
                                                        if (bytes != null)
                                                        {
                                                            string subkeyName;
                                                            for (int i = 0; i < bytes.Length; i += 4)
                                                            {
                                                                subkeyName =
                                                                    String.Format("{0,2:X}", bytes[i + 3]).Replace(' ', '0') +
                                                                    String.Format("{0,2:X}", bytes[i + 2]).Replace(' ', '0') +
                                                                    String.Format("{0,2:X}", bytes[i + 1]).Replace(' ', '0') +
                                                                    String.Format("{0,2:X}", bytes[i]).Replace(' ', '0');
                                                                using (RegistryKey subKey3 = subKey2.OpenSubKey(subkeyName, false))
                                                                {
                                                                    if (subKey3 != null)
                                                                    {
                                                                        byte[] accountName = (byte[])subKey3.GetValue("Account Name", null);
                                                                        if (accountName != null)
                                                                        {
                                                                            accounts[accounts.Count] = UnicodeEncoding.Unicode.GetString(accountName).Replace("\0", String.Empty);
                                                                            if (accounts.Count == 1)
                                                                                defaultAccount = (string)accounts[i];
                                                                        }

                                                                        byte[] email = (byte[])subKey3.GetValue("Email", null);
                                                                        if (email != null)
                                                                        {
                                                                            emails[emails.Count] = UnicodeEncoding.Unicode.GetString(email).Replace("\0", String.Empty);
                                                                            if (emails.Count == 1)
                                                                                defaultEmail = (string)emails[i];
                                                                        }
                                                                        /*else
                                                                        {   
                                                                            // if there is an Exchange account in Outlook 
                                                                            email = (byte[])subKey3.GetValue("Identity Eid", null);
                                                                            if (email != null)
                                                                            {
                                                                                s = UnicodeEncoding.UTF8.GetString(email).Replace("\0", String.Empty);
                                                                                s = s.Substring(9, s.Length - 9);
                                                                                emails[emails.Count] = s;
                                                                                if (emails.Count == 1)
                                                                                {
                                                                                    defaultEmail = s;
                                                                                }
                                                                            }
                                                                        }*/
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else if (version == 9)
                {
                    registryPath = "Software\\Microsoft\\Office\\Outlook\\OMI Account Manager";
                    using (RegistryKey key = Registry.CurrentUser.OpenSubKey(registryPath, false))
                    {
                        if (key != null)
                        {
                            string s = (string)key.GetValue("Default Mail Account", String.Empty);
                            if (s != String.Empty)
                            {
                                using (RegistryKey subKey = key.OpenSubKey("Accounts", false))
                                {
                                    if (subKey != null)
                                    {
                                        if (subKey.SubKeyCount > 0)
                                        {
                                            string accountName, email;
                                            string[] names = subKey.GetSubKeyNames();
                                            for (int i = 0; i < names.Length; i++)
                                            {
                                                using (RegistryKey subKey2 = subKey.OpenSubKey(names[i], false))
                                                {
                                                    if (subKey2 != null)
                                                    {
                                                        accountName = (string)subKey2.GetValue("Account Name", String.Empty);
                                                        if (accountName != String.Empty)
                                                        {
                                                            accounts[accounts.Count] = accountName;
                                                            if (accountName == s)
                                                                defaultAccount = accountName;
                                                        }

                                                        email = (string)subKey2.GetValue("Email", String.Empty);
                                                        if (email != String.Empty)
                                                        {
                                                            emails[emails.Count] = email;
                                                            if (email == s)
                                                                defaultEmail = email;
                                                        }
                                                        /*else
                                                        {
                                                            // this code was not tested with Outlook 2000 + Exchange Server
                                                            email = (string)subKey2.GetValue("Identity Eid", String.Empty);
                                                            if (email != String.Empty)
                                                            {
                                                                email = email.Substring(9, email.Length - 9);
                                                                emails[emails.Count] = email;
                                                                if (email == s)
                                                                    defaultEmail = email;
                                                            }
                                                        }*/
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        private void adxOutlookEvents_ItemSend(object sender, AddinExpress.MSO.ADXOlItemSendEventArgs e)
        {
            MessageBox.Show(GetSenderName(e.Item));
        }

        private string GetSenderName(object item)
        {
            object mapiObject = null;
            Outlook._MailItem mail = null;
            string senderEmail = String.Empty;

            if (item is Outlook._MailItem)
            {
                mail = item as Outlook._MailItem;
                mail.Save();

                mapiObject = mail.MAPIOBJECT;

                if (mapiObject != null)
                {
                    string senderType = String.Empty;
                    IntPtr unk = IntPtr.Zero;
                    IntPtr unkObj = IntPtr.Zero;

                    try
                    {
                        unkObj = Marshal.GetIUnknownForObject(mapiObject);
                        Guid iMapiProp = new Guid("00020303-0000-0000-C000-000000000046");
                        Marshal.QueryInterface(unkObj, ref iMapiProp, out unk);
                        if (unk != IntPtr.Zero)
                        {
                            IntPtr pPropValue = IntPtr.Zero;

                            try
                            {
                                MAPI.HrGetOneProp(unk, MAPI.PR_NEWMESSAGE_SENDER_EMAIL_ADDRESS, out pPropValue);
                                MAPI.SPropValue propValue = (MAPI.SPropValue)Marshal.PtrToStructure(pPropValue, typeof(MAPI.SPropValue));
                                propValue.Value &= 0xFFFFFFFF;
                                senderEmail = Marshal.PtrToStringAnsi(new IntPtr(propValue.Value));
                            }
                            catch
                            {
                            }
                            if (pPropValue != IntPtr.Zero)
                                MAPI.MAPIFreeBuffer(pPropValue);

                            if (senderEmail != String.Empty)
                            {
                                senderEmail = senderEmail.Substring(9, senderEmail.Length - 9);
                            }
                            else
                            {
                                Accounts registeredAccounts = new Accounts();
                                registeredAccounts.Load(this.HostVersion);
                                if (registeredAccounts.DefaultEmail != String.Empty)
                                    senderEmail = registeredAccounts.DefaultEmail;
                            }
                        }
                    }
                    finally
                    {
                        Marshal.Release(unkObj);
                        if (unk != IntPtr.Zero) Marshal.Release(unk);
                        Marshal.ReleaseComObject(mapiObject);
                    }
                }
            }
            return senderEmail;
        }

    }
}

